bullets = {}

Bullet = class("Bullet", Actor)

function Bullet:initialize(x, y, angle, team)
	Actor.initialize(self, x, y)
	self:SetAngle(angle)
	self.team = team
	
	self.speed = 300
	self.vel = vector(math.cos(angle) * self.speed, math.sin(angle) * self.speed)
	
	bullets[self] = true
end

function Bullet:Die()
	bullets[self] = nil
end

function Bullet:update(dt)
	Actor.update(self, dt)
	if self.pos.x < 0 or self.pos.x > xres or self.pos.y < 0 or self.pos.y > yres then
		self:Die()
		-- print("bullet died")
		return
	end
	
	if self.team == "player" then
		for k in pairs(enemies) do
			if Intersecting(self, k) then
				self:Die()
				k:Die()
			end
		end
	elseif player then
		if Intersecting(self, player) then
			player:Damage(10)
			self:Die()
		end
	end
end

function Bullet:draw()
	love.graphics.setColor(0, 255, 0, 192)
	love.graphics.draw(image, self.pos.x, self.pos.y, self.angle, 0.25, 0.25, 16, 16)
end
