function SpawnEnemy(x, y)
	local enemy = Enemy:new(x, y)
end

enemies = {}

Enemy = class("Enemy", Actor)

function Enemy:initialize(x, y)
	Actor.initialize(self, x, y)
	self.color = {255, 0, 0}
	self.team = "enemy"
	
	enemies[self] = true
	
	self.updatetime = 0.5
	self.time = self.updatetime
end

function Enemy:update(dt)
	Actor.update(self, dt)
	if player then
		local angle = math.atan2(player.pos.y-self.pos.y, player.pos.x-self.pos.x) - math.pi/2
		self:SetAngle(angle)
	end
	
	if self.time > 0 then
		self.time = self.time - dt
	else
		self.time = self.updatetime
		self:FireBullet()
	end
end

function Enemy:Die()
	Event.Trigger("ENEMY_DIE", self)
	enemies[self] = nil
end
