function Intersecting(o1, o2)
	if o1.pos:dist(o2.pos) < 16 then -- wat
		return true
	end
	return false
end

function love.load()
	math.randomseed(os.time()); math.random() math.random() math.random()
	
	require("middleclass")
	vector = require("vector")
	require("event")
	
	image = love.graphics.newImage("test5.png")
	
	require("actor")
	require("player")
	require("enemy")
	require("blackhole")
	require("bullet")
	
	xres, yres = love.graphics.getWidth(), love.graphics.getHeight()
	
	player = Player(xres/2, yres/2)
	
	for i=1, 4 do
		SpawnEnemy(math.random(xres), math.random(yres))
	end
	
	Event.Register(OnPlayerDie, "PLAYER_DIE")
end

function love.keypressed(key)
	if key == "escape" then
		love.event.quit()
	elseif key == " " and player then
		player:FireBullet()
	end
end

maxdietime = 1
dietime = 0
function OnPlayerDie()
	dietime = 0
end


function love.update(dt)
	for k in pairs(blackholes) do k:update(dt) end
	for k in pairs(enemies) do k:update(dt) end
	for k in pairs(bullets) do k:update(dt) end
	if player then
		local v = vector(0, 0)
		if love.keyboard.isDown("w") then
			v.y = -1
		elseif love.keyboard.isDown("s") then
			v.y = 1
		end
		if love.keyboard.isDown("a") then
			v.x = -1
		elseif love.keyboard.isDown("d") then
			v.x = 1
		end
		if v:len() > 0 then
			v:normalize_inplace()
		end
				
		local mv = vector(love.mouse.getPosition())
		local angle = math.atan2(mv.y-player.pos.y, mv.x-player.pos.x) - math.pi/2
		player:SetAngle(angle)
		
		player:Move(v)
		
		player:update(dt)
	end
	
	if not player then
		dietime = dietime + dt
		if dietime >= maxdietime then
			player = Player(xres/2, yres/2)
		end
	end
end

function love.draw()
	for k in pairs(blackholes) do k:draw() end
	for k in pairs(enemies) do k:draw() end
	for k in pairs(bullets) do k:draw() end
	if player then
		player:draw()
	end
	
	love.graphics.setColor(255, 255, 255)
	love.graphics.print(string.format("Score: %d", player and player.score or 0), 10, 10)
	love.graphics.print(string.format("Health: %d", player and player.health or 0), 10, 28)
end

